﻿XIncludeFile #PB_Compiler_Home+"Inc\HID_Module.pbi"

#USB_PID       = $33  ; Идентификаторы программатора PicKit2.
#USB_VID       = $4D8

#END_OF_BUFFER = $AD  ; Этим заполняется пустое пространство в буфере.
#PACKET_SIZE   =  65  ; Размер HID репорта программатора.

Procedure VddOn(Handle) ; Включить питание
  Dim OutBuffer.a(#PACKET_SIZE+2)
  FillMemory(@OutBuffer()+1, #PACKET_SIZE, #END_OF_BUFFER, #PB_Byte)  ; Заполнение массива, данными из константы #END_OF_BUFFER
  OutBuffer(0)=0
  OutBuffer(1)=$A6 ; EXECUTE_SCRIPT
  OutBuffer(2)=2
  OutBuffer(3)=$FC ; _VDD_GND_OFF
  OutBuffer(4)=$FF ; _VDD_ON
  ProcedureReturn HID::WriteDevice(Handle, @OutBuffer(), #PACKET_SIZE) ; Передача данных в программатор PICkit2
EndProcedure

Procedure VddOff(Handle) ; Выключить питание
  Dim OutBuffer.a(#PACKET_SIZE+2)
  FillMemory(@OutBuffer()+1, #PACKET_SIZE, #END_OF_BUFFER, #PB_Byte)  ; Заполнение массива, данными из константы #END_OF_BUFFER
  OutBuffer(0)=0
  OutBuffer(1)=$A6 ; EXECUTE_SCRIPT
  OutBuffer(2)=2
  OutBuffer(3)=$FE ; _VDD_OFF
  OutBuffer(4)=$FD ; _VDD_GND_ON
  ProcedureReturn HID::WriteDevice(Handle, @OutBuffer(), #PACKET_SIZE) ; Передача данных в программатор PICkit2
EndProcedure

HID::HID_Init()

Handle=HID::OpenDevice(#USB_PID, #USB_VID) ; Установка связи с PicKit2
If Handle
  VddOn(Handle)  ; Включить питание
  Delay(2000)    ; Пауза 2 секунды
  VddOff(Handle) ; Выключить питание
  HID::CloseDevice(Handle)  ; Разрыв связи с PicKit2
Else
  MessageRequester("", "Нет связи с PicKit2!", 48)
EndIf

HID::HID_End()
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; Folding = -
; EnableXP
; CompileSourceDirectory