XIncludeFile #PB_Compiler_Home+"Inc\PureAutoIt.pbi"
UseModule PureAutoIt

; Create a file.
Procedure FileCreate(sFilePath.s, sString.s)
  fReturn = #True ; Create a variable to store a boolean value.
  If Not FileExists(sFilePath)
    fReturn = FileWrite(sFilePath, sString)
  EndIf
  ProcedureReturn fReturn
EndProcedure

Procedure Example()
  ; Create a constant variable in Local scope of the filepath that will be read/written to.
  sFilePath.s = _TempDir() + "\FileGetTime.txt"

  ; Create a temporary file to read data from.
  If Not FileCreate(sFilePath, "This is an example of using FileGetTime.")
    ProcedureReturn MsgBox(#MB_SYSTEMMODAL, "", "An error occurred whilst writing the temporary file.")
  EndIf

  ; Set the modified timestamp of the file to 1st Nov 2003 and use the current time.
  iFileSetTime = FileSetTime(sFilePath, "20031101", #FT_MODIFIED)

  ; Display the modified timestamp of the file and return as a string in the format YYYYMMDDHHMMSS.
  If iFileSetTime
    MsgBox(#MB_SYSTEMMODAL, "", "Timestamp:" + #CRLF$ + FileGetTime(sFilePath, #FT_MODIFIED, 1))
  Else
    MsgBox(#MB_SYSTEMMODAL, "", "An error occurred whilst setting the timestamp of the file.")
  EndIf

  ; Delete the temporary file.
  FileDelete(sFilePath)
EndProcedure

Example()
