XIncludeFile #PB_Compiler_Home+"Inc\PureAutoIt.pbi"
UseModule PureAutoIt

; Create a file.
Procedure FileCreate(sFilePath.s, sString.s)
  fReturn = #True ; Create a variable to store a boolean value.
  If Not FileExists(sFilePath)
    fReturn = FileWrite(sFilePath, sString)
  EndIf
  ProcedureReturn fReturn
EndProcedure

Procedure Example()
  ; Create a constant variable in Local scope of the filepath that will be read/written to.
  sFilePath.s = _TempDir() + "\FileReadLine.txt"

  ; Create a temporary file to read data from.
  If Not FileCreate(sFilePath, "This is an example of using FileReadLine.")
    ProcedureReturn MsgBox(#MB_SYSTEMMODAL, "", "An error occurred whilst writing the temporary file.")
  EndIf

  ; Open the file for reading and store the handle to a variable.
  hFileOpen.s = FileOpen(sFilePath, #FO_READ)
  If hFileOpen = ""
    MsgBox(#MB_SYSTEMMODAL, "", "An error occurred when reading the file.")
    ProcedureReturn #False
  EndIf

  ; Read the fist line of the file using the handle returned by FileOpen.
  sFileRead.s = FileReadLine(hFileOpen, 1)

  ; Close the handle returned by FileOpen.
  FileClose(hFileOpen)

  ; Display the first line of the file.
  MsgBox(#MB_SYSTEMMODAL, "", "First line of the file:" + #CRLF$ + sFileRead)

  ; Delete the temporary file.
  FileDelete(sFilePath)
EndProcedure

Example()
