EnableExplicit


; Flags fr das TabBarGadget (kombinierbar mit | )
Enumeration
	#TabBarGadget_CloseButton = %0001 ; fgt jedem Tab ein Schlieen-Button [X] hinzu
	#TabBarGadget_EmptyButton = %0010 ; fgt einen leeren Tab hinzu
	#TabBarGadget_Navigation  = %0100 ; INTERN
EndEnumeration


; Events fr das TabBarGadget
Enumeration
	#TabBarGadget_Event_NewTab   = 1 ; ein neuer Tab wird angefordert
	#TabBarGadget_Event_CloseTab = 2 ; ein Tab soll geschlossen werden
	#TabBarGadget_Event_Change   = 3 ; Der aktive Tab wurde gendert
	#TabBarGadget_Event_Swap     = 4 ; Der aktive Tab wurde verschoben
EndEnumeration



Structure TabBarGadgetItem
	Text.s
	ImageID.i
	DataValue.i
	Width.i
	X.i
EndStructure

Structure TabBarGadget
	Flags.i
	List Item.TabBarGadgetItem()
	*CurrentItem.TabBarGadgetItem
	*MoveItem.TabBarGadgetItem
	MouseX.i
	MouseY.i
	Event.i
	Shift.i
	CheckTab.i
EndStructure

Structure TabBarGadgetInclude
	FaceColor.i
	LightColor.i
	ShadowColor.i
	FontID.i
	Padding.i
	Margin.i
	ImageSpace.i
	CrossSize.i
	ArrowSize.i
	Radius.i
EndStructure

Global TabBarGadgetInclude.TabBarGadgetInclude

With TabBarGadgetInclude
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Windows
			\ShadowColor = GetSysColor_(#COLOR_3DSHADOW)|$FF<<24
			\FaceColor   = GetSysColor_(#COLOR_3DFACE)|$FF<<24
			\LightColor  = GetSysColor_(#COLOR_3DHIGHLIGHT)|$FF<<24
		CompilerDefault
			\ShadowColor = $FF808080
			\FaceColor   = $FFD0D0D0
			\LightColor  = $FFFFFFFF
	CompilerEndSelect
	\FontID      = FontID(LoadFont(#PB_Any, "Arial", 9))
	\Padding     = 6
	\Margin      = 4
	\ImageSpace  = 3
	\CrossSize   = 8
	\ArrowSize   = 6
	\Radius      = 7
EndWith




Procedure TabBarGadget_MouseIn(*TabBarGadget.TabBarGadget, X.i, Y.i, Width.i, Height.i)
	With *TabBarGadget
		If Width < 0 : X + Width : Width * -1 : EndIf
		If Height < 0 : Y + Height : Height * -1 : EndIf
		If \MouseX >= X And \MouseX <= X+Width And \MouseY >= Y And \MouseY <= Y+Height
			ProcedureReturn #True
		EndIf
	EndWith
EndProcedure

Procedure TabBarGadget_DrawCross(X.i, Y.i, Size.i, Color.i, Border.i=#False)
	Protected Alpha.i = Alpha(Color)/4
	Line(X, Y+1, Size-1, Size-1, Color&$FFFFFF|Alpha<<24)
	Line(X+1, Y, Size-1, Size-1, Color&$FFFFFF|Alpha<<24)
	Line(X, Y+Size-2, Size-1, -Size+1, Color&$FFFFFF|Alpha<<24)
	Line(X+1, Y+Size-1, Size-1, -Size+1, Color&$FFFFFF|Alpha<<24)
	Line(X, Y, Size, Size, Color)
	Line(X, Y+Size-1, Size, -Size, Color)
	If Border
		Alpha * 2
		DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
		Box(X-2, Y-2, Size+4, Size+4, Color&$FFFFFF|Alpha<<24)
		DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_AlphaBlend)
	EndIf
EndProcedure

Procedure TabBarGadget_DrawArrow(X.i, Y.i, Size.i, Color.i, Border.i=#False)
	Protected Index.i, Alpha.i = Alpha(Color)/2
	If Size > 0
		For Index = 0 To Size
			Line(X+Index, Y-Index, 1, Index*2+1, Color)
		Next
	ElseIf Size < 0
		For Index = 0 To -Size
			Line(X-Index, Y-Index, 1, Index*2+1, Color)
		Next
	EndIf
EndProcedure


Procedure.i TabBarGadget_DrawItem(*TabBarGadget.TabBarGadget, *Item.TabBarGadgetItem, DrawMode.i=1)
	
	Protected X.i, Y.i, Color.i, ShiftY.i, Width.i
	
	With TabBarGadgetInclude
		
		DrawingFont(\FontID)
		DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_AlphaBlend|#PB_2DDrawing_Gradient)
		If EventType() = #PB_EventType_MouseLeave 
			Color = $A0000000
			LinearGradient(0, 0, 0, OutputHeight()*0.75-1)
		ElseIf TabBarGadget_MouseIn(*TabBarGadget, *Item\X, \Margin, *Item\Width, OutputHeight()) And *TabBarGadget\MoveItem = #Null
			If EventType() = #PB_EventType_LeftButtonDown 
				If DrawMode
					If *TabBarGadget\CurrentItem <> *Item
						*TabBarGadget\Event = #TabBarGadget_Event_Change
					EndIf
					*TabBarGadget\CurrentItem = *Item
					*TabBarGadget\MoveItem = *Item
				Else
					*TabBarGadget\Event = #TabBarGadget_Event_NewTab
				EndIf
			ElseIf EventType() = #PB_EventType_MiddleButtonDown
				*TabBarGadget\Event = #TabBarGadget_Event_CloseTab
				*TabBarGadget\CurrentItem = *Item
				*TabBarGadget\MoveItem = #Null
			EndIf
			Color = $FF000000
			LinearGradient(0, OutputHeight()/3, 0, OutputHeight()-1)
		Else
			Color = $A0000000
			LinearGradient(0, 0, 0, OutputHeight()*0.75-1)
		EndIf
		If DrawMode = 2
			LinearGradient(0, OutputHeight()/3, 0, OutputHeight()-1)
			Color = $FF000000
		EndIf
		GradientColor(0.0, \LightColor)
		GradientColor(1.0, \FaceColor)
		
		Select DrawMode
			Case 0, 1
				X = *Item\X : Y = \Margin
				Width = *Item\Width
				ShiftY = \Margin
			Case 2
				X = *Item\X-\Margin/2 : Y = 0
				Width = *Item\Width + \Margin
				ShiftY = \Margin/2
		EndSelect
		RoundBox(X, Y, Width, OutputHeight()+\Radius, \Radius, \Radius)
		DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_AlphaBlend|#PB_2DDrawing_Outlined)
		RoundBox(X, Y, Width, OutputHeight()+\Radius, \Radius, \Radius, \ShadowColor)
		DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_AlphaBlend)
		If *Item\ImageID
			DrawImage(*Item\ImageID, *Item\X+\Padding, ShiftY+(OutputHeight()-16)/2, 16, 16)
			X = *Item\X + \Padding + 16 + \ImageSpace
		Else
			X = *Item\X + \Padding
		EndIf
		Y = (OutputHeight()-TextHeight(*Item\Text))/2 - \Margin/2 + ShiftY + 1
		DrawText(X, Y, *Item\Text, Color)
		
		If *TabBarGadget\Flags & #TabBarGadget_CloseButton And DrawMode
			Y = ShiftY + (OutputHeight()-\CrossSize)/2
			X = *Item\X + *Item\Width - \CrossSize - \Padding
			If TabBarGadget_MouseIn(*TabBarGadget, X, Y, \CrossSize, \CrossSize) And (*TabBarGadget\MoveItem=0 Or *TabBarGadget\MoveItem=*Item)
				TabBarGadget_DrawCross(X, Y, \CrossSize, $FF000000, #True)
				If EventType() = #PB_EventType_LeftButtonDown 
					*TabBarGadget\Event = #TabBarGadget_Event_CloseTab
					*TabBarGadget\MoveItem = #Null
				EndIf
			Else
				TabBarGadget_DrawCross(X, Y, \CrossSize, $A0000000)
			EndIf
		EndIf
		
	EndWith
	
EndProcedure

Procedure TabBarGadget_Update(Gadget.i)
	
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	Protected X.i, Y.i, EmptyItem.TabBarGadgetItem, MaxWidth.i, MinWidth.i, Width.i, ShowWith.i, Show.i
	
	With *TabBarGadget
		
		\MouseX = GetGadgetAttribute(Gadget, #PB_Canvas_MouseX)
		\MouseY = GetGadgetAttribute(Gadget, #PB_Canvas_MouseY)
		
		If StartDrawing(CanvasOutput(Gadget))
			
			DrawingFont(TabBarGadgetInclude\FontID)
			
			; Maximale mgliche Breite aller Tabs:
			MaxWidth = OutputWidth()-TabBarGadgetInclude\Margin*2
			If \Flags & #TabBarGadget_EmptyButton
				MaxWidth - OutputHeight() 
			EndIf
			If \Flags & #TabBarGadget_Navigation
				MaxWidth - (TabBarGadgetInclude\ArrowSize+TabBarGadgetInclude\Margin)*2
			EndIf
			
			; Breiten ermitteln
			If \CheckTab And \CurrentItem
				ChangeCurrentElement(\Item(), \CurrentItem)
				If ListIndex(\Item()) < \Shift
					\Shift = ListIndex(\Item())
					\CheckTab = #False
				EndIf
			EndIf
			Repeat
				Width = 0
				ShowWith = 0
				ForEach \Item()
					\Item()\Width = TextWidth(\Item()\Text) + 2*TabBarGadgetInclude\Padding
					If \Flags & #TabBarGadget_CloseButton
						\Item()\Width + TabBarGadgetInclude\CrossSize + TabBarGadgetInclude\Padding
					EndIf
					If \Item()\ImageID
						\Item()\Width + 16 + TabBarGadgetInclude\ImageSpace
					EndIf
					Width + \Item()\Width-1
					If ListIndex(\Item()) >= \Shift
						ShowWith + \Item()\Width-1
					EndIf
					If \Item() = \CurrentItem And ShowWith < MaxWidth
						\CheckTab = #False
					EndIf
				Next
				If \CheckTab
					\Shift + 1
				EndIf
			Until \CheckTab = #False
			
			Repeat
				If \Shift And SelectElement(\Item(), \Shift-1)
					If ShowWith + \Item()\Width < MaxWidth
						\Shift - 1
						ShowWith + \Item()\Width-1
					Else
						Break
					EndIf
				Else
					Break
				EndIf
			ForEver
			
			; Navigation ntig ?
			If Width >= MaxWidth
				\Flags | #TabBarGadget_Navigation
			Else
				\Flags & ~#TabBarGadget_Navigation
			EndIf
			
			DrawingMode(#PB_2DDrawing_AlphaBlend)
			
			Box(0, 0, OutputWidth(), OutputHeight(), TabBarGadgetInclude\FaceColor)
			
			; Navigation
			If \Flags & #TabBarGadget_Navigation
				Y = OutputHeight()/2+TabBarGadgetInclude\Margin
				If \Shift < 1
					TabBarGadget_DrawArrow(TabBarGadgetInclude\Margin, Y, TabBarGadgetInclude\ArrowSize, $20000000)
				ElseIf TabBarGadget_MouseIn(*TabBarGadget, TabBarGadgetInclude\Margin, Y-TabBarGadgetInclude\ArrowSize, TabBarGadgetInclude\ArrowSize, TabBarGadgetInclude\ArrowSize*2+1)
					TabBarGadget_DrawArrow(TabBarGadgetInclude\Margin, Y, TabBarGadgetInclude\ArrowSize, $FF000000, #True)
					If EventType() = #PB_EventType_LeftButtonDown Or \MoveItem
						\Shift - 1
					EndIf
				Else
					TabBarGadget_DrawArrow(TabBarGadgetInclude\Margin, Y, TabBarGadgetInclude\ArrowSize, $80000000)
				EndIf
				If ShowWith < MaxWidth
					TabBarGadget_DrawArrow(OutputWidth()-TabBarGadgetInclude\Margin, Y, -TabBarGadgetInclude\ArrowSize, $20000000)
				ElseIf TabBarGadget_MouseIn(*TabBarGadget, OutputWidth()-TabBarGadgetInclude\Margin, Y-TabBarGadgetInclude\ArrowSize, -TabBarGadgetInclude\ArrowSize, TabBarGadgetInclude\ArrowSize*2+1)
					TabBarGadget_DrawArrow(OutputWidth()-TabBarGadgetInclude\Margin, Y, -TabBarGadgetInclude\ArrowSize, $FF000000, #True)
					If EventType() = #PB_EventType_LeftButtonDown Or \MoveItem
						\Shift + 1
					EndIf
				Else
					TabBarGadget_DrawArrow(OutputWidth()-TabBarGadgetInclude\Margin, Y, -TabBarGadgetInclude\ArrowSize, $80000000)
				EndIf
				X = TabBarGadgetInclude\Margin*2 + TabBarGadgetInclude\ArrowSize
			Else
				X = TabBarGadgetInclude\Margin
			EndIf
			
			If TabBarGadget_MouseIn(*TabBarGadget, X+ShowWith, 0, OutputWidth()-X-ShowWith-X, OutputHeight())
				If EventType() = #PB_EventType_LeftDoubleClick
					*TabBarGadget\Event = #TabBarGadget_Event_NewTab
				EndIf
			EndIf
			
			Width = 0
			If SelectElement(\Item(), \Shift)
				Repeat
					\Item()\X = X + Width
					If Width + \Item()\Width > MaxWidth
						Break
					EndIf
					If \CurrentItem = \Item()
						Show = #True
					Else
						TabBarGadget_DrawItem(*TabBarGadget, \Item())
					EndIf
					Width + \Item()\Width - 1
				Until Not NextElement(\Item())
			EndIf
			EmptyItem\X = X + Width
			EmptyItem\Width = OutputHeight()
			If \Flags & #TabBarGadget_EmptyButton
				TabBarGadget_DrawItem(*TabBarGadget, EmptyItem, 0)
			EndIf
			If Show
				TabBarGadget_DrawItem(*TabBarGadget, \CurrentItem, 2)
			EndIf
			
			If EventType() = #PB_EventType_LeftButtonUp
				*TabBarGadget\MoveItem = #Null
			ElseIf *TabBarGadget\MoveItem
				If Not \Event
					ChangeCurrentElement(\Item(), *TabBarGadget\MoveItem)
					While NextElement(\Item())
						If \MouseX > \Item()\X
							SwapElements(\Item(), @\Item(), *TabBarGadget\MoveItem)
							\Item()\X = *TabBarGadget\MoveItem\X
							*TabBarGadget\MoveItem\X = \Item()\X + \Item()\Width
							\Event = #TabBarGadget_Event_Swap
						EndIf
					Wend
				EndIf
				If Not \Event
					ChangeCurrentElement(\Item(), *TabBarGadget\MoveItem)
					While PreviousElement(\Item()) And ListIndex(\Item()) >= \Shift
						If *TabBarGadget\MoveItem\Width < \Item()\Width
							MinWidth = *TabBarGadget\MoveItem\Width
						Else
							MinWidth = \Item()\Width
						EndIf
						If \MouseX < \Item()\X + MinWidth
							SwapElements(\Item(), @\Item(), *TabBarGadget\MoveItem)
							*TabBarGadget\MoveItem\X = \Item()\X
							\Item()\X = *TabBarGadget\MoveItem\X + *TabBarGadget\MoveItem\Width
							\Event = #TabBarGadget_Event_Swap
						EndIf
					Wend
				EndIf
			EndIf
			
			StopDrawing()
			
		EndIf
		
	EndWith
	
EndProcedure



; Gibt ein TabBarGadget wieder frei
Procedure FreeTabBarGadget(Gadget.i)
	
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	
	ClearStructure(*TabBarGadget, TabBarGadget)
	FreeMemory(*TabBarGadget)
	
	FreeGadget(Gadget)
	
EndProcedure



; Erstellt ein TabBarGadget
Procedure TabBarGadget(Gadget.i, X.i, Y.i, Width.i, Height.i, Flags.i=#Null)
	
	Protected *TabBarGadget.TabBarGadget = AllocateMemory(SizeOf(TabBarGadget))
	Protected Result.i
	
	InitializeStructure(*TabBarGadget, TabBarGadget)
	Result = CanvasGadget(Gadget, X, Y, Width, Height)
	If Gadget = #PB_Any
		Gadget = Result
	EndIf
	SetGadgetData(Gadget, *TabBarGadget)
	
	With *TabBarGadget
		\Flags = Flags
	EndWith
	
	TabBarGadget_Update(Gadget)
	
	ProcedureReturn Result
	
EndProcedure


; Gibt das aktuelle Ereignis des TabBarGadget zurck (und aktuallisiert es)
Procedure TabBarGadgetEvent(Gadget.i)
	
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	
	*TabBarGadget\Event = #Null
	TabBarGadget_Update(Gadget)
	ProcedureReturn *TabBarGadget\Event
	
EndProcedure



;-



; Fgt einen neuen Tab hinzu
Procedure.i AddTabBarGadgetItem(Gadget.i, Position.i, Text.s, ImageID.i=0, DataValue.i=0)
	
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	
	With *TabBarGadget
		If Position = #PB_Default Or Not SelectElement(\Item(), Position)
			AddElement(\Item())
		Else
			InsertElement(\Item())
		EndIf
	EndWith
	
	With *TabBarGadget\Item()
		\Text      = Text
		\ImageID   = ImageID
		\DataValue = DataValue
	EndWith
	
	TabBarGadget_Update(Gadget)
	
	ProcedureReturn ListIndex(*TabBarGadget\Item())
	
EndProcedure



; Entfernt einen Tab
Procedure RemoveTabBarGadgetItem(Gadget.i, Position.i)
	
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	
	With *TabBarGadget
		If SelectElement(\Item(), Position)
			DeleteElement(\Item())
			If NextElement(\Item())
				\CurrentItem = @\Item()
			Else
				\CurrentItem = LastElement(\Item())
			EndIf
		EndIf
	EndWith
	
	TabBarGadget_Update(Gadget)
	
EndProcedure



; ndert den aktuellen Tab
Procedure SetTabBarGadgetState(Gadget.i, State.i)
	
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	
	With *TabBarGadget
		If SelectElement(\Item(), State)
			\CurrentItem = @\Item()
			\CheckTab = #True
		EndIf
	EndWith
	
	TabBarGadget_Update(Gadget)
	
EndProcedure



; Gibt den aktuellen Tab zurck
Procedure GetTabBarGadgetState(Gadget.i)
	
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	
	With *TabBarGadget
		If \CurrentItem
			ChangeCurrentElement(\Item(), \CurrentItem)
			ProcedureReturn ListIndex(\Item())
		Else
			ProcedureReturn -1
		EndIf
	EndWith
	
EndProcedure



; ndert den Data-Wert des angegebenen Tabs
Procedure SetTabBarGadgetItemData(Gadget.i, Position.i, DataValue.i)
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	If SelectElement(*TabBarGadget\Item(), Position)
		*TabBarGadget\Item()\DataValue = DataValue
	EndIf
EndProcedure



; Gibt den Data-Wert des angegebenen Tabs zurck
Procedure GetTabBarGadgetItemData(Gadget.i, Position.i)
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	If SelectElement(*TabBarGadget\Item(), Position)
		ProcedureReturn *TabBarGadget\Item()\DataValue
	EndIf
EndProcedure



; ndert den Text des angegebenen Tabs
Procedure SetTabBarGadgetItemText(Gadget.i, Position.i, Text.s)
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	If SelectElement(*TabBarGadget\Item(), Position)
		*TabBarGadget\Item()\Text = Text
	EndIf
EndProcedure



; Gibt den Text des angegebenen Tabs zurck
Procedure.s GetTabBarGadgetItemText(Gadget.i, Position.i)
	Protected *TabBarGadget.TabBarGadget = GetGadgetData(Gadget)
	If SelectElement(*TabBarGadget\Item(), Position)
		ProcedureReturn *TabBarGadget\Item()\Text
	EndIf
EndProcedure










Enumeration
	#Window
	#TabBarGadget
	#ContainerGadget
EndEnumeration

UsePNGImageDecoder()

OpenWindow(#Window, 0, 0, 800, 600, "WindowTitle", #PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_SizeGadget)
	SmartWindowRefresh(#Window, #True)
	TabBarGadget(#TabBarGadget, 5, 5, WindowWidth(#Window)-10, 25, #TabBarGadget_CloseButton|#TabBarGadget_EmptyButton)
		AddTabBarGadgetItem(#TabBarGadget, #PB_Default, "PureBoard  Foren-bersicht")
		AddTabBarGadgetItem(#TabBarGadget, #PB_Default, "Google", ImageID(CatchImage(#PB_Any, ?world)))
		AddTabBarGadgetItem(#TabBarGadget, #PB_Default, "GMX - E-Mail")
		AddTabBarGadgetItem(#TabBarGadget, #PB_Default, "YouTube - Broadcast Yourself", ImageID(CatchImage(#PB_Any, ?star)))
	SetTabBarGadgetState(#TabBarGadget, 1)
	ContainerGadget(#ContainerGadget, 5, 30, WindowWidth(#Window)-10, WindowHeight(#Window)-35, #PB_Container_Double)
	

Define Position.i

Repeat
	
	Select WaitWindowEvent()
			
		Case #PB_Event_CloseWindow
			End
		
		Case #PB_Event_SizeWindow
			ResizeGadget(#TabBarGadget, 5, 5, WindowWidth(#Window)-10, 25)
			ResizeGadget(#ContainerGadget, 5, 30, WindowWidth(#Window)-10, WindowHeight(#Window)-35)
			TabBarGadgetEvent(#TabBarGadget)
			
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #TabBarGadget
					Select TabBarGadgetEvent(#TabBarGadget)
						Case #TabBarGadget_Event_NewTab
							Debug "Event: NewTab"
							Position = AddTabBarGadgetItem(#TabBarGadget, #PB_Default, "Neuer Tab "+Str(Random(1000)))
							SetTabBarGadgetState(#TabBarGadget, Position)
						Case #TabBarGadget_Event_CloseTab
							Debug "Event: CloseTab"
							RemoveTabBarGadgetItem(#TabBarGadget, GetTabBarGadgetState(#TabBarGadget))
						Case #TabBarGadget_Event_Change
							Debug "Event: ChangeState"
							Debug "  Position: "+Str(GetTabBarGadgetState(#TabBarGadget))
							Debug "  Text: "+GetTabBarGadgetItemText(#TabBarGadget, GetTabBarGadgetState(#TabBarGadget))
						Case #TabBarGadget_Event_Swap
							Debug "Event: Swap"
							Debug "  Position: "+Str(GetTabBarGadgetState(#TabBarGadget))
							Debug "  Text: "+GetTabBarGadgetItemText(#TabBarGadget, GetTabBarGadgetState(#TabBarGadget))
					EndSelect
			EndSelect
			
	EndSelect
	
ForEver

DataSection
	world:
	Data.q $0A1A0A0D474E5089,$524448490D000000,$1000000010000000,$FFF31F0000000608,$5845741900000061
	Data.q $72617774666F5374,$2065626F64410065,$6165526567616D49,$00003C65C9717964,$DA78544144493003
	Data.q $C7187556687B9364,$DB176DEF673DE73F,$8B68979CDB9B59A5,$92E906B374988CD5,$11A3417024442B12
	Data.q $88E502E94A0B2235,$47FC0C116823FB02,$D853BDA50D090282,$9A936E5CCDA61D22,$DF5777B77BA6EF6C
	Data.q $9836BCEFD39FB9EB,$CF7E77EFCE0783F5,$FE2479E7DF3CF7E7,$F2DA65DFD27ED6B3,$E805F9C30523B6AB
	Data.q $D1D67D9343E28AAA,$D75DF5737C9F8F99,$3BBD9D1536569175,$2F3744F73C8E4354,$23693CD96366596D
	Data.q $FD20E5F13CE4F5C6,$95F88BC8FBF16F43,$03BDEE9F0FCDCB6C,$A452B861D919D950,$458FB5B07CC3FB7D
	Data.q $FC274C9DB9918F33,$8B7B99A6B820278C,$2FD9F8E66F1C19FB,$3CF803C41CC92809,$BC4DCDFD915A6E80
	Data.q $A46E1EF654CA50D6,$A690656C7E52C442,$DA2972B54C581AFB,$82BFB6FB1F4D634E,$0E2AFB912B228569
	Data.q $FDCF65ADA86D74F7,$9425D2E853D0586B,$25DDCB3C5754B7D0,$60DFCA1B0EA9CC6D,$7EA37FE7A3887624
	Data.q $871523FCD81E55DD,$D5B76D8E00E575CF,$216CF12E1F15AE56,$1B094CEB201DCF7F,$635728CA07593263
	Data.q $F8EB672C551AA39F,$63857DD68F20E479,$D281492B80396DCB,$99854166D5598870,$8534F6D209DD640C
	Data.q $4DBD37C781C1EFE1,$713032AC9F147061,$50079F840D52CA90,$E92261A46E22E1C2,$0963445DE436D9A0
	Data.q $8C5D8596242BFBD3,$C09EA846B52DCBBE,$9B9C51BB36B8B3E7,$BE35767464C835B7,$1A3161344398B9C0
	Data.q $DB339F6AF1C0487F,$431D1CB047EB8185,$45EF9CDF1A38E03C,$23F8D71900DB8D91,$C684C99FA84142DA
	Data.q $528BCF335FC03A7C,$51B6B7D338F86441,$0F464796949A745E,$72B38226AA3CB590,$CB60DF44FC748504
	Data.q $CDC892FC72F2E2DE,$1DF531E6EE19E9B5,$B66EA1A9C3DFA99E,$3509137E71467D54,$62742F270AF84944
	Data.q $EBD5259BFC4E1625,$5E44DAAAEF267B3A,$DD055C7175542820,$D8DBEA5A619AA00A,$F15C222BD13BFEBA
	Data.q $EBD0CAE65F974FF8,$29A4688D5B68FCDC,$923A5FE1B4A691AF,$2DBA52693324E3D3,$112C8084AD515542
	Data.q $C606CE4BE4507C5D,$99F0EA00F970B99A,$95156F02256FCF0E,$AFA9E1BF3FB43BED,$A4A60140AC12FCED
	Data.q $3EB49A890A138E88,$358F12B67FAFCED2,$A7C3F4B1DD3B5E62,$20F2618EF24F84C7,$A57DEC77BE5736C2
	Data.q $17C37E4924B76CA8,$EE72761B2F29CE44,$633B885FBD91ECE4,$16AAD571A6FFF39E,$276899D56855EA56
	Data.q $08FFCE3D5EC25716,$115D936F14FB0030,$454900000000F4B5,$0000826042AE444E
EndDataSection

DataSection
	star:
	Data.q $0A1A0A0D474E5089,$524448490D000000,$1000000010000000,$FFF31F0000000608,$5845741900000061
	Data.q $72617774666F5374,$2065626F64410065,$6165526567616D49,$00003C65C9717964,$DA78544144490502
	Data.q $FE1451544BCF53A4,$6C0D191C73D37DEE,$645D219A08A9B06C,$10B4492042836931,$407E8608862D9689
	Data.q $265DA13FA11B807F,$2D8DC6D568B45952,$54526381240C145A,$9986B52F4C92A11A,$0CE7DCEDCEFBB1A6
	Data.q $DF7BDF0BA213CDA8,$F79CF73DDF3BF7BD,$F7BF7AF8DF86B5A0,$9BBB17BEDFB6E32A,$E8CCBE2DDD7B2941
	Data.q $793C7E66DFA40CDD,$3D07870D979D8ECB,$64854F53F593A7EE,$0C0C3B7F6048EB63,$CEA13BA9570327FF
	Data.q $8FCF0C1E67B5A00B,$670F301B4F507A9F,$D526B8EABB426FA2,$051A3B0835797205,$C031E8EC89E37CFD
	Data.q $1690D32763F3A60A,$56F2CD6584E40C84,$577D2D8BA22033DA,$579C46C1248E1A9A,$9A66D14811E5682B
	Data.q $1570B1EE97221C95,$9855DE785AFC1502,$10A4A9840C6A3A9E,$CEDED4F758F2C4E2,$A071340B5F7B1143
	Data.q $4ACE6E5AAB09DBE6,$BC7E029C36254F10,$D8E39D5E640E745D,$81E99962660D5A99,$098D902349A7ECF9
	Data.q $65CC136A46CB916E,$0BB3E63ACACA8128,$71167662603C1C93,$5BE6FD26EE70F4F6,$0268876D287CCD59
	Data.q $C2EDD6D18D182D95,$AA1C5B4F6A7768D2,$183C754D764F8EF0,$BA58E244080FC54E,$5FA149636DF293DB
	Data.q $5194070E1BD08286,$581C553860F45B9A,$0835F7EAB2C51B61,$E59519F8A886C7B7,$FCBC1FDE5F733875
	Data.q $77D5A6B370C0C7A2,$D510FF7F436D2384,$DD7B0F3B5074F6B1,$22D8ED3C1B896BD1,$57719F1EDF6B30EB
	Data.q $AC6D6B635BD59C9F,$8EC28C8FEFAB25AD,$DBD7F2AF1199AE8F,$31006011FC67FE0C,$00AD8E7D6FB902FF
	Data.q $AE444E4549000000,$0000000000826042
EndDataSection
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 670
; FirstLine = 629
; Folding = ---
; EnableXP