; FileVersion - by akee   (http://www.purebasic.fr/english/viewtopic.php?f=12&t=42358&hilit=GetFileVersionInfo_)
; AnimGIFGadget - by ts-soft  (http://www.purebasic.fr/english/viewtopic.php?f=12&t=49407&hilit=AnimGIFGadget)
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ 
; Description   : ResourceViewer
; Author        : Pablov
; Version       : 0.1
; Created       : 01.07.2015
; Updated       : 01.07.2015
; PureBasic     : 5.30
; OS            : Only Windows XP ; 7 & above
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Enumeration
  #Window_0
EndEnumeration

Enumeration
  #Tree_0
  #Edit
  #img
  #Container
  #Splitter
  #MainMenu
  #Open
  #Exit
  #About
  #txt
  #imgLogo
EndEnumeration

Enumeration
  #FVI_FileVersion      = $0001
  #FVI_FileDescription  = $0002
  #FVI_LegalCopyright   = $0004
  #FVI_InternalName     = $0008
  #FVI_OriginalFilename = $0010
  #FVI_ProductName      = $0020
  #FVI_ProductVersion   = $0040
  #FVI_CompanyName      = $0080
  #FVI_LegalTrademarks  = $0100
  #FVI_SpecialBuild     = $0200
  #FVI_PrivateBuild     = $0400
  #FVI_Comments         = $0800
  #FVI_Language         = $1000
  #FVI_Email            = $1001
  #FVI_Website          = $1002
  #FVI_Special          = $1003
EndEnumeration

#FVIRTKEY  = $1
#FNOINVERT = $2
#FSHIFT    = $4          
#FCONTROL  = $8
#FALT      = $10

;#AVIFILE$ = "C:\tmp.avi"

XIncludeFile "AnimGIFGadget.pbi"
;Import "Data\rv.res" : EndImport

UsePNGImageDecoder()

Define.l Event, EventWindow, EventGadget, EventType, EventMenu

Structure ACCEL_TABLE_ENTRY
   fFlags.w
   wASCII.w
   wID.w
   wPadding.w
 EndStructure  
 
Declare.s GetString(a.s, b)
Declare.s GetAccelerators(a.s, b)
Declare.b ShowDialog(a.s, b, c)
Declare.s GetHexDump(a.s, b)
Declare.b GetPicture(a.s, b)
Declare.b GetPNG(a.s, b)
Declare.b GetAVI(a.s, b)

Global hModule, hDialog, sMenuText.s
Global gdiplus.b

Structure RES
  hRes.i
  SizeRes.i
EndStructure

Procedure MsgError()
  MessageRequester("Error", "Can't read the resource. Maybe the app is packed")
EndProcedure

Procedure WinCallback(Win,msg,wParam,lParam) 
  Select msg 
    Case #WM_SIZE 
      ResizeGadget(#Edit, #PB_Ignore, #PB_Ignore, GadgetWidth(#Container) - 8, GadgetHeight(#Container) - 8)
      ResizeGadget(#Splitter, #PB_Ignore, #PB_Ignore, WindowWidth(#Window_0) - 10, WindowHeight(#Window_0) - 105)
      ResizeGadget(#txt, #PB_Ignore, GadgetHeight(#Splitter) + 20, #PB_Ignore, #PB_Ignore)
      ResizeGadget(#imgLogo,  WindowWidth(#Window_0) - 130 ,GadgetHeight(#Splitter) + 40, #PB_Ignore, #PB_Ignore)
   EndSelect 
  ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure 

Procedure FreeResMem(*stRes.RES)
  FreeResource_(*stRes\hRes)
  FreeMemory(*stRes)  
EndProcedure

Procedure GetResource(Name.s, type, *stRes.RES)
  Protected.i hRes, hGlob, lpbArray
  ;       
  hRes= FindResource_(hModule,@Name, type)
  If hRes
    ;    ,     . 
    hGlob = LoadResource_(hModule, hRes) 
    lpbArray = LockResource_(hGlob)
    *stRes\hRes    = hGlob
    *stRes\SizeRes = SizeofResource_(hModule, hRes)
    ProcedureReturn *stRes
  EndIf
EndProcedure

Procedure.l IsNumeric(String$) 
  ; check if only numbers 0-9 are used in the string 
  ; returns 1 (true)  for number-string, 
  ; returns 0 (false) if other chars are found 
  If String$ 
    *p.BYTE = @String$ 
    Repeat 
      char = *p\b & $FF 
      If (char >= '0' And char <= '9') Or char=0 
        *p+1 
      Else 
        ProcedureReturn 0 
      EndIf 
    Until char = 0 
    ProcedureReturn 1 
  EndIf 
EndProcedure 

Procedure BinOrText(ResName.s, ResType)    
;       ,   
 Protected byte.b, *stRes.RES
 *stRes = AllocateMemory(SizeOf(RES))
  GetResource(ResName, ResType, *stRes.RES)
  If *stRes\SizeRes > 0
    For i = 0 To *stRes\SizeRes - 1
     byte = PeekB(*stRes\hRes + i)
     Select byte
       Case 0 To 31, 127 To 191 
         If byte = 10 Or byte = 13 Or byte = 9   ;     
         Else 
           FreeResMem(*stRes.RES)
           ProcedureReturn #False               ;  
         EndIf
     EndSelect
    Next i
    FreeResMem(*stRes.RES)
    ProcedureReturn #True                       ; 
 EndIf
EndProcedure

Procedure RefreshView()
  If hDialog : DestroyWindow_(hDialog) : hDialog = 0 : EndIf
  SetGadgetState(#img, 0)
  ClearGadgetItems(#Edit)
;   If FileSize(#AVIFILE$)
;       mciSendString_("close video", @"", 0, 0)
;       DeleteFile(#AVIFILE$)
;   EndIf
  FreeAnimGIFGadget()
EndProcedure
 
Procedure.s ParentItemText(gadgethandle)
  Protected current=SendMessage_(gadgethandle,#TVM_GETNEXTITEM,#TVGN_CARET,0)
  Protected parent=SendMessage_(gadgethandle,#TVM_GETNEXTITEM,#TVGN_PARENT,current)
  If parent
    parenttext$=Space(260)
    text.TV_ITEM
    text\mask=#TVIF_TEXT
    text\hItem=parent
    text\pszText=@parenttext$
    text\cchTextMax=260
    SendMessage_(gadgethandle,#TVM_GETITEM,0,@text)
    ProcedureReturn parenttext$
  Else
    ProcedureReturn ""
  EndIf
EndProcedure

Procedure ResSize(ResName.s, ResType)
  Protected hRsrc
  If ResType & $ffff0000
     resType$ = ParentItemText(GadgetID(#Tree_0))
     hRsrc = FindResource_(hModule, @ResName, @resType$)
  Else
     hRsrc = FindResource_(hModule, @ResName, ResType)
  EndIf
   If hRsrc
     FreeResource_(hRsrc)
     ProcedureReturn SizeofResource_(hModule, hRsrc)
   EndIf
EndProcedure

Procedure.s GetFileVersionInfo_ElementName(ElementFlag)
  Protected TempString$ = ""
  Select ElementFlag
    Case #FVI_FileVersion
      TempString$ = "FileVersion"
    Case #FVI_FileDescription
      TempString$ = "FileDescription"
    Case #FVI_LegalCopyright
      TempString$ = "LegalCopyright"
    Case #FVI_InternalName
      TempString$ = "InternalName"
    Case #FVI_OriginalFilename
      TempString$ = "OriginalFilename"
    Case #FVI_ProductName
      TempString$ = "ProductName"
    Case #FVI_ProductVersion
      TempString$ = "ProductVersion"
    Case #FVI_CompanyName
      TempString$ = "CompanyName"
    Case #FVI_LegalTrademarks
      TempString$ = "LegalTrademarks"
    Case #FVI_SpecialBuild
      TempString$ = "SpecialBuild"
    Case #FVI_PrivateBuild
      TempString$ = "PrivateBuild"
    Case #FVI_Comments
      TempString$ = "Comments"
    Case #FVI_Language
      TempString$ = "Language"
    Case #FVI_Email
      TempString$ = "Email"
    Case #FVI_Website
      TempString$ = "Website"
    Case #FVI_Special
      TempString$ = "Special"
  EndSelect
  ProcedureReturn TempString$
EndProcedure

Procedure.s GetFileVersionInfoString(lptstrFilename$, FVI_Flag)
  Protected TempString$ = "", TempPtr, TempBlkSize, *TempBlk
  Protected TempBuff, TempBuffSize, TempCPLI$, TempLangSize = 128, TempLang$ = Space(TempLangSize)
      TempBlkSize = GetFileVersionInfoSize_(lptstrFilename$, @TempPtr)
      If TempBlkSize > 0
        *TempBlk = AllocateMemory(TempBlkSize)
        If *TempBlk > 0
          If GetFileVersionInfo_(lptstrFilename$, 0, TempBlkSize, *TempBlk)
            If VerQueryValue_(*TempBlk, "\\VarFileInfo\\Translation", @TempBuff, @TempBuffSize)
              TempCPLI$ = RSet(Hex(PeekW(TempBuff)), 4, "0") + RSet(Hex(PeekW(TempBuff + 2)), 4, "0")
              VerLanguageName_(PeekW(TempBuff), TempLang$, TempLangSize)
            EndIf 
            If VerQueryValue_(*TempBlk, "\\StringFileInfo\\" + TempCPLI$ + "\\" + GetFileVersionInfo_ElementName(FVI_Flag), @TempBuff, @TempBuffSize)
              TempString$ = PeekS(TempBuff, TempBuffSize)
            EndIf
            If FVI_Flag = #FVI_Language
              TempString$ = TempLang$
            EndIf
          EndIf
        EndIf
        FreeMemory(*TempBlk)
      EndIf
  ProcedureReturn(TempString$)
EndProcedure

Procedure.s GetResourceTypeString(dwType)
  Protected ResTypeString.s
  Select dwType
     Case #RT_ACCELERATOR  : ResTypeString = "ACCELERATOR - Accelerator table."
     Case #RT_ANICURSOR    : ResTypeString = "ANICURSOR - Animated cursor."
     Case #RT_ANIICON      : ResTypeString = "ANIICON - Animated icon."
     Case #RT_BITMAP       : ResTypeString = "BITMAP - Bitmap resource."
     Case #RT_CURSOR       : ResTypeString = "CURSOR - Hardware-dependent cursor resource."
     Case #RT_DIALOG       : ResTypeString = "DIALOG - Dialog box."
     Case #RT_DLGINCLUDE   : ResTypeString = "DLGINCLUDE Allows a resource editing tool to associate"
     Case #RT_FONT         : ResTypeString = "FONT - Font resource."
     Case #RT_FONTDIR      : ResTypeString = "FONTDIR - Font directory resource."
     Case #RT_GROUP_CURSOR : ResTypeString = "GROUP_CURSOR - Hardware-independent cursor resource."
     Case #RT_GROUP_ICON   : ResTypeString = "GROUP_ICON - Hardware-independent icon resource."
     Case #RT_HTML         : ResTypeString = "HTML - HTML."
     Case #RT_ICON         : ResTypeString = "ICON - Hardware-dependent icon resource."
     Case #RT_MANIFEST     : ResTypeString = "MANIFEST - Microsoft Windows XP: Side-by-Side Assembly XML Manifest."
     Case #RT_MENU         : ResTypeString = "MENU - Menu resource."
     Case #RT_MESSAGETABLE : ResTypeString = "MESSAGETABLE - Message-table entry."
     Case #RT_PLUGPLAY     : ResTypeString = "PLUGPLAY - Plug and Play resource."
     Case #RT_RCDATA       : ResTypeString = "RCDATA - Application-defined resource (raw data)."
     Case #RT_STRING       : ResTypeString = "STRING - String-table entry."
     Case #RT_VERSION      : ResTypeString = "VERSION - Version resource."
     Case #RT_VXD          : ResTypeString = "VXD - VXD."
     Default               : ResTypeString = "USER_DEFINED"  
   EndSelect
   ProcedureReturn ResTypeString
EndProcedure

Procedure tvExpandNode(gadget.l, item.l, flag.l)
  ; Expands, or collapses a TreeViewNode.
  ;Usage:
  ;*************
  ; gadget.l  = PB Gadget Number
  ; item.l    = Item to expand/collapse
  ; flag.l    = If 0: the Node collapses
  ;             If 1: the Node is expanded
  ;             If 2: the Node is expanded, if it was collapsed, and it's collapsed, if it was expanded
  hwndTV.l = GadgetID(gadget)
  hItem.l = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_ROOT, 0)
  For i.l = 0 To item-1
    hItem2.l = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_CHILD, hItem)
    Repeat
      If hItem2 = #Null: hItem2 = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_NEXT, hItem): EndIf
      If hItem2 = #Null: hItem2 = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_PARENT, hItem): EndIf
    Until hItem2 <> #Null
    hItem = hItem2
  Next i
  If flag = 1
    SendMessage_(hwndTV, #TVM_EXPAND, #TVE_EXPAND, hItem)
  ElseIf flag=2
    SendMessage_(hwndTV, #TVM_EXPAND, #TVE_TOGGLE, hItem)
  Else
    SendMessage_(hwndTV, #TVM_EXPAND, #TVE_COLLAPSE, hItem)
  EndIf
EndProcedure

Procedure.s GetText(ResName.s, ResType)
 Protected text.s
 Protected *stRes.RES
 *stRes = AllocateMemory(SizeOf(RES))
 If *stRes
     GetResource(ResName, ResType, *stRes.RES)
   If *stRes\SizeRes > 0
     text = Space(*stRes\SizeRes)
     text = PeekS(*stRes\hRes, *stRes\SizeRes, #PB_Ascii)
     FreeResMem(*stRes.RES)
     ProcedureReturn text
   Else
     FreeMemory(*stRes)  
     ProcedureReturn ""
   EndIf
 EndIf  
EndProcedure

Procedure IsResPNGorGIF(ResName.s, ResType) 
 Protected *stRes.RES
 *stRes = AllocateMemory(SizeOf(RES))
 If *stRes
     GetResource(ResName, ResType, *stRes)
   If *stRes\SizeRes > 0                        ;   
     If PeekC(*stRes\hRes)  = 137 And PeekS(*stRes\hRes+1, 3) = "PNG" 
       FreeResMem(*stRes.RES)
       ProcedureReturn 1
     ElseIf PeekS(*stRes\hRes, 6) = "GIF89a" Or PeekS(*stRes\hRes, 6) = "GIF87a"
       FreeResMem(*stRes.RES)
       ProcedureReturn 2
     Else
       FreeResMem(*stRes.RES)
       ProcedureReturn #False
     EndIf 
       FreeResMem(*stRes.RES)
    EndIf
 EndIf
EndProcedure

Procedure.s GetMenuInfo(hMenu, level)
    Protected itemcount, i, retval, str$ = Space(256)
    Protected mii.MENUITEMINFO
    itemcount = GetMenuItemCount_(hMenu)
    With mii
        \cbSize = SizeOf(MENUITEMINFO)
        \fMask = #MIIM_STATE | #MIIM_TYPE | #MIIM_SUBMENU | #MIIM_ID
        For i = 0 To itemcount - 1
            \dwTypeData = @str$
            \cch = 256
            retval = GetMenuItemInfo_(hMenu, i, 1, mii)
            If \fType = #MFT_SEPARATOR
               sMenuText = sMenuText + RSet("", 5 * level, ".") + "[MENU SEPARATOR]" + #CRLF$
            Else
               sMenuText = sMenuText + RSet("", 5 * level, ".") + Left(PeekS(\dwTypeData), \cch)
               If \fState & #MFS_CHECKED : sMenuText = sMenuText + " (checked)" : EndIf
               sMenuText = sMenuText + " (cmdID = " + \wID + ")" + #CRLF$
            EndIf
            If \hSubMenu <> 0 : GetMenuInfo(\hSubMenu, level+1) : EndIf
        Next i
    EndWith
    ProcedureReturn sMenuText
EndProcedure

Procedure.s GetMenuText(ResName.s)
   Protected hMenu
   sMenuText = ""
   hMenu = LoadMenu_(hModule, ResName)
   If hMenu
     sMenuText = GetMenuInfo(hMenu, 0)
     DestroyMenu_(hMenu)
   EndIf
   ProcedureReturn sMenuText
EndProcedure

Procedure CreateGif(type.i, x.i, y.i, *typeRes, res.s = "", color.i = 0)
  Protected *stRes.RES, AniGadget
  *stRes = AllocateMemory(SizeOf(RES))
  If *stRes 
    Select type
     Case #PB_GadgetType_Canvas
         GetResource(res, *typeRes, *stRes)
         If *stRes\SizeRes > 0
            AniGadget = AnimGIFGadgetMem(#PB_Any, x, y, *stRes\hRes, *stRes\SizeRes, color)
            FreeResMem(*stRes.RES)
            ProcedureReturn AniGadget
         EndIf  
    EndSelect
    FreeResMem(*stRes.RES)
  EndIf  
  ProcedureReturn AniGadget
EndProcedure

Procedure ShowResource()
  Protected CurrentText.s = GetGadgetItemText(#Tree_0, GetGadgetState(#Tree_0), 0), resSize, resType$, rt$
   If IsNumeric(CurrentText)
     CurrentText = "#" + CurrentText
   EndIf  
   resSize  = ResSize(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
   resType$ = ParentItemText(GadgetID(#Tree_0))
   rt$ = "   ResType:" +  Chr(9) + resType$ + #CRLF$
   rt$ = rt$ + "   ResName:" +  Chr(9) + CurrentText + #CRLF$
   rt$ = rt$ + "   ResSize:" +  Chr(9) + Str(resSize)
   SetGadgetText(#txt, rt$)
   
   Select GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0))
      Case #RT_STRING 
        ClearGadgetItems(#Edit)
        String$ = GetString(CurrentText, #RT_STRING)
        If String$
           SetGadgetText(#Edit, String$)
        Else  
           MsgError()
        EndIf 
      Case #RT_MANIFEST  
        ClearGadgetItems(#Edit)
        String$ = GetText(CurrentText, #RT_MANIFEST)
        If String$
           SetGadgetText(#Edit, String$)
        Else  
           MsgError()
        EndIf 
      Case #RT_MENU
        ClearGadgetItems(#Edit)
        String$ = GetMenuText(CurrentText)
        If String$
           SetGadgetText(#Edit, String$)
        Else  
           MsgError()
        EndIf 
      Case #RT_VERSION
        ClearGadgetItems(#Edit)
        File$ = Space(#MAX_PATH)
        GetModuleFileName_(hModule, File$, #MAX_PATH)
        tstr$ = GetFileVersionInfo_ElementName(#FVI_FileVersion) + ": "
        ver$ = "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_FileVersion) + #CRLF$ 
        tstr$ = GetFileVersionInfo_ElementName(#FVI_FileDescription) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_FileDescription) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_LegalCopyright) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_LegalCopyright) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_InternalName) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_InternalName) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_OriginalFilename) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_OriginalFilename) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_ProductName) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_ProductName) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_ProductVersion) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_ProductVersion) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_CompanyName) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_CompanyName) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_LegalTrademarks) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_LegalTrademarks) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_SpecialBuild) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_SpecialBuild) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_PrivateBuild) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_PrivateBuild) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_Comments) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_Comments) + #CRLF$
        tstr$ = GetFileVersionInfo_ElementName(#FVI_Language) + ": "
        ver$ = ver$ + "  " + tstr$ + RSet(" ", 21 - Len(tstr$), ".") + GetFileVersionInfoString(File$, #FVI_Language) 
        SetGadgetText(#Edit, ver$)
      Case #RT_ACCELERATOR
        ClearGadgetItems(#Edit)
        String$ = GetAccelerators(CurrentText, #RT_ACCELERATOR)
        If String$
           SetGadgetText(#Edit, String$)
        Else  
           MsgError()
        EndIf 
      Case #RT_DIALOG, #RT_DLGINCLUDE  
        ResType = GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0))
        ShowDialog(CurrentText, ResType, #img)
      Case #RT_CURSOR, #RT_BITMAP, #RT_ICON, #RT_GROUP_CURSOR, #RT_GROUP_ICON  ;"1", "2", "3", "12", "14" 
        RefreshView()
        ResType = GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0))
        If GetPicture(CurrentText, ResType) = 0
           MsgError()
        EndIf
      Case #RT_RCDATA 
        res = IsResPNGorGIF(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
        If res = 1                 ;    PNG
           If GetPNG(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
              ProcedureReturn
           EndIf
        ElseIf res = 2             ;    GIF
         If gdiplus
            AniGadget = CreateGif(#PB_GadgetType_Canvas, 100, 100, #RT_RCDATA, CurrentText, GetSysColor_(#COLOR_BTNFACE))
            If AniGadget : ProcedureReturn : EndIf
         EndIf
        Else
           If resSize > 50000
             If MessageRequester("", "Text too long to display it in text box."+ #CRLF$ + "        To continue or not?",#PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                Goto m1
             EndIf
           Else
            m1:
               bt = BinOrText(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
               If bt > 0           ;   
                   String$ = GetText(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
                 If String$
                   SetGadgetText(#Edit, String$)
                 Else  
                   MsgError()
                 EndIf 
               Else                ;   
                   String$ = GetHexDump(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
                 If String$
                   SetGadgetText(#Edit, String$)
                 Else  
                   MsgError()
                 EndIf 
               EndIf
           EndIf
        EndIf 
      Case #RT_HTML                                ; 23
        ClearGadgetItems(#Edit)
     ;   String$ = GetHTML(CurrentText, #RT_HTML)
        String$ = GetText(CurrentText, #RT_HTML)


        If String$
           SetGadgetText(#Edit, String$)
        Else  
           MsgError()
        EndIf 
      Default  
          If resType$ = "AVI"
              If GetAVI(CurrentText, @"AVI")
                 ProcedureReturn
              EndIf
          EndIf
          If GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)) & $ffff0000
            res = IsResPNGorGIF(CurrentText, @resType$)
            If res = 1               ;    PNG
               If GetPNG(CurrentText, @resType$) : ProcedureReturn : EndIf
            ElseIf  res = 2
              If gdiplus
                 AniGadget = CreateGif(#PB_GadgetType_Canvas, 100, 100, @resType$, CurrentText, GetSysColor_(#COLOR_BTNFACE))
                 If AniGadget : ProcedureReturn : EndIf
              EndIf
            EndIf
          Else 
            res = IsResPNGorGIF(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
            If res
               GetPNG(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
            EndIf
          EndIf
          If res = 0                ;   PNG   GIF,   HEX  
               If GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)) & $ffff0000
                 bt = BinOrText(CurrentText, @resType$)
               Else 
                 bt = BinOrText(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
               EndIf
               If bt > 0            ;   
                 If GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)) & $ffff0000
                   String$ = GetText(CurrentText, @resType$)
                 Else
                   String$ = GetText(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
                 EndIf 
                 If String$
                   SetGadgetText(#Edit, String$)
                 Else  
                   MsgError()
                 EndIf 
               Else                 ;   
                 If resSize > 50000
                   If MessageRequester("", "Text too long to display it in text box."+ #CRLF$ + "        To continue or not?",#PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                     Goto m2
                   EndIf
                 Else
                   m2:
                    If GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)) & $ffff0000
                       String$ = GetHexDump(CurrentText, @resType$)
                    Else
                       String$ = GetHexDump(CurrentText, GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0)))
                    EndIf 
                    If String$
                      SetGadgetText(#Edit, String$)
                    Else  
                      MsgError()
                    EndIf 
                 EndIf
               EndIf
          EndIf
   EndSelect 
EndProcedure  

Procedure ResNamesCallBack(hMod, ResType, ResId, lParam)
    Protected ResName.s
    If ResId & $ffff0000 
       ResName = PeekS(ResId)
    Else
       ResName = Str(ResId)
    EndIf
    AddGadgetItem(#Tree_0, -1, ResName, ExtractIcon_(0, "Shell32.dll", 70), 2)
    SetGadgetItemData(#Tree_0, CountGadgetItems(#Tree_0) - 1, ResType)
    ProcedureReturn #True
EndProcedure

Procedure ResTypesCallBack(hMod, ResType, lParam)
    Protected ResTypeN.s, ret
    If ResType & $ffff0000
       ResTypeN = PeekS(ResType)                                  ;      
    Else 
         ResTypeN = GetResourceTypeString(ResType) + " [" + Str(ResType) + "]"
    EndIf
    AddGadgetItem(#Tree_0, -1, ResTypeN, ExtractIcon_(0, "Shell32.dll", 3), 1)
    ret = EnumResourceNames_(hMod, ResType, @ResNamesCallBack(), 0)    
    ProcedureReturn #True
EndProcedure

Procedure InitResource(sLibName.s)
  ProcedureReturn LoadLibraryEx_(sLibName, 0, 1)
EndProcedure

Procedure FillResTypes(hModule)
   If hModule 
       EnumResourceTypes_(hModule, @ResTypesCallBack(), 0)
   EndIf
EndProcedure

Procedure GetDataArray(Array arr.b(1), ResType, ResName.s)
  Protected.l hRsrc, hGlobal, lpData, arrSize
  hRsrc = FindResource_(hModule, @ResName, ResType)
  If hRsrc
     hGlobal = LoadResource_(hModule, hRsrc)
     lpData = LockResource_(hGlobal)
     arrSize = SizeofResource_(hModule, hRsrc)
     If arrSize = 0 : FreeResource_(hGlobal) : ProcedureReturn #False : EndIf
     ReDim arr(arrSize)
     CopyMemory(lpData, @arr(0), arrSize)
     FreeResource_(hGlobal)
     ProcedureReturn #True
  Else
     ProcedureReturn #False
  EndIf  
EndProcedure

Procedure.s GetString(ResName.s, ResType)
 Protected  Dim arr.b(0)
 Protected.l nPos, wID, uLength
 Protected.s s, sText
 If GetDataArray(arr(), ResType, ResName)
   For wID = (Val(Mid(ResName, 2)) - 1) * 16 To Val(Mid(ResName, 2)) * 16 - 1
     CopyMemory(@arr(nPos), @uLength, 2)
       If uLength
          s = Space(uLength)
          s = PeekS(@arr(nPos + 2), uLength, #PB_Unicode) 
          s = ReplaceString(s, Chr(13) + Chr(10), "")         ;    
          s = ReplaceString(s, Chr(10), "\n")
          s = "  " + Str(wID) + ":  " + Chr(39) + s + Chr(39)
          sText = sText + Trim(s, "0") + #CRLF$
          nPos = nPos + uLength * 2 + 2
       Else
          nPos = nPos + 2
       EndIf
   Next wID
 EndIf        
 ProcedureReturn sText
EndProcedure

Procedure.b ShowDialog(ResName.s, ResType, img)
  Protected rc.RECT, rcPic.RECT, *stRes.RES
Shared hWndDlg
  ; hDialog = CreateDialogParam_(hModule, ResName, GadgetID(img), 0, 0)  
   *stRes = AllocateMemory(SizeOf(RES))
      GetResource(ResName, ResType, *stRes.RES)
   If *stRes\SizeRes > 0
     hDialog = CreateDialogIndirectParam_(hModule, *stRes\hRes, GadgetID(img), 0, 0)   
     If hDialog
       If GetParent_(hDialog) = GadgetID(img)
          GetWindowRect_(hDialog, rc)
          MoveWindow_(hDialog, 0, 0, rc\Right - rc\Left, rc\Bottom - rc\Top, 1)
       Else
          GetWindowRect_(hDialog, rc)
          GetWindowRect_(GadgetID(img), rcPic)
          MoveWindow_(hDialog, rcPic\Left+10, rcPic\Top+10, rc\Right - rc\Left, rc\Bottom - rc\Top, 1)
       EndIf
       ShowWindow_(hDialog, #SW_SHOWNORMAL)
       SetWindowText_(hDialog, "Dialog - " + ResName) 
       FreeResMem(*stRes.RES)
       ProcedureReturn #True
     EndIf
      FreeResMem(*stRes.RES)
      ProcedureReturn #False
   EndIf
EndProcedure  
  
Procedure.s GetKeyName(key)
  name$ = Space(#MAX_PATH) 
  GetKeyNameText_(MapVirtualKey_(key, 0) * $10000, @name$, #MAX_PATH)
  ProcedureReturn name$
EndProcedure

Procedure.b GetPicture(ResName.s, ResType)
 Protected hData, *stRes.RES, image.s
   Select ResType
      Case #RT_CURSOR, #RT_ICON
        *stRes = AllocateMemory(SizeOf(RES))
        If *stRes
           GetResource(ResName, ResType, *stRes.RES)
           If *stRes\SizeRes > 0
              hData = CreateIconFromResourceEx_(*stRes\hRes, *stRes\SizeRes + 1, ResType - 1, $30000, 0, 0, #LR_LOADMAP3DCOLORS)
              If ResType - 1 = 0
                image = "CURSOR"
              Else
                image = "ICO"
              EndIf  
              FreeResMem(*stRes.RES)
           EndIf
        EndIf 
      Case #RT_BITMAP                      ;Bitmap
         hData = LoadImage_(hModule, ResName, 0, 0, 0, #LR_LOADMAP3DCOLORS)
                image = "BITMAP"
      Case #RT_GROUP_CURSOR 
         hData = LoadImage_(hModule, ResName, 2, 0, 0, #LR_LOADMAP3DCOLORS)
                image = "CURSOR"
      Case #RT_GROUP_ICON
         hData = LoadImage_(hModule, ResName, 1, 0, 0, #LR_LOADMAP3DCOLORS)
         image = "ICO"
    EndSelect
      If hData = 0 : ProcedureReturn #False : EndIf
      SetGadgetState(#img, hData)
      HideGadget(#img, 0)
      If  ResType <> #RT_CURSOR And ResType <> #RT_GROUP_CURSOR
         SetGadgetText(#Edit, "Image info: "  + #CRLF$ + image + #CRLF$ + "Size: " + GadgetWidth(#img) + "x" + GadgetHeight(#img))   
      Else
         SetGadgetText(#Edit, "Image info: "  + #CRLF$ + image + #CRLF$ + "Size: " + 32 + "x" + 32)   
         ResizeGadget(#img, 100, 100, 820, 660) ;   -    ????????
      EndIf  
      RedrawWindow_(WindowID(#Window_0),0,0,#RDW_INVALIDATE | #RDW_ERASE)
      UpdateWindow_(WindowID(#Window_0))
      ProcedureReturn #True   
EndProcedure

Procedure.b GetAVI(ResName.s, ResType)
   Protected *stRes.RES, ret
   *stRes = AllocateMemory(SizeOf(RES))
   If *stRes
      GetResource(ResName, ResType, *stRes.RES)
      If *stRes\SizeRes > 0
;         file$ = #AVIFILE$
;         If OpenFile(0, file$)
;            WriteData(0, *stRes\hRes, *stRes\SizeRes)
;            mciCmd$ = "open " + file$ + " Type avivideo Alias video parent " +  Str(GadgetID(#img)) + " Style child"
;            ret = mciSendString_(mciCmd$, @"", 0, 0)
;            If ret > 0 : ProcedureReturn #False : EndIf
;            If mciSendString_("put video window at " + 0 + " " + 0 + " " + 0 + " " + 0, @"", 0, 0) = 0
;              mciSendString_("play video repeat", @"", 0, 0)
;              RedrawWindow_(WindowID(#Window_0),0,0,#RDW_INVALIDATE | #RDW_ERASE)
;              UpdateWindow_(WindowID(#Window_0))
;              FreeResource_(hGlobal)
;              CloseFile(0)
;              FreeResMem(*stRes.RES)
;              ProcedureReturn #True
;            EndIf
;           CloseFile(0)
;        EndIf
       FreeResMem(*stRes.RES)
       ProcedureReturn #False
      EndIf
   EndIf
EndProcedure

Procedure.b GetPNG(ResName.s, ResType)
   Protected *stRes.RES, hData
   *stRes = AllocateMemory(SizeOf(RES))
   If *stRes
     GetResource(ResName, ResType, *stRes.RES)
     If *stRes\SizeRes > 0
       hData = CatchImage(#img, *stRes\hRes, *stRes\SizeRes)
       SetGadgetState(#img, hData)
       RedrawWindow_(WindowID(#Window_0),0,0,#RDW_INVALIDATE | #RDW_ERASE)
       UpdateWindow_(WindowID(#Window_0))
       FreeResMem(*stRes.RES)
       ProcedureReturn #True
     EndIf
     FreeMemory(*stRes)  
   EndIf
EndProcedure

Procedure.s GetAccelerators(ResName.s, ResType)
 Protected nItems, i
 Protected Dim arr.b(0)
 Protected Dim ate.ACCEL_TABLE_ENTRY(0)
 Protected sText.s, sTxt.s
 If GetDataArray(arr(), ResType, ResName)
   nItems = (ArraySize(arr()) + 1) / 8     
   ReDim ate(nItems - 1)
   CopyMemory(@arr(0), @ate(0), nItems * 8)
   For i = 0 To nItems - 1
       If (ate(i)\fFlags & #FSHIFT) : sText = sText + "Shift+" : EndIf
       If (ate(i)\fFlags & #FCONTROL) : sText = sText + "Ctrl+" : EndIf
       If (ate(i)\fFlags & #FALT) : sText = sText + "Alt+" : EndIf
       sTxt =  sTxt + "  (cmdID = " + ate(i)\wID + ")" + Chr(9) + Chr(34) + sText + GetKeyName(ate(i)\wASCII) + Chr(34) + #CRLF$
       sText = ""
   Next i
 EndIf  
 ProcedureReturn sTxt
EndProcedure

Procedure.s GetHexDump(ResName.s, ResType)
 Protected Dim arr.c(0)
 Protected.s sText, sLine
   Protected *stRes.RES, ret
   *stRes = AllocateMemory(SizeOf(RES))
 If *stRes
     GetResource(ResName, ResType, *stRes.RES)
   If *stRes\SizeRes > 0
     ReDim arr(*stRes\SizeRes)
     CopyMemory(*stRes\hRes, @arr(0), *stRes\SizeRes)
     SetCursor_(LoadCursor_(0, #IDC_WAIT))
     For i = 0 To ArraySize(arr()) - 1 Step 16
       sLine = RSet(Hex(i, #PB_Long), 8, "0") + " | "
       For j = 0 To 15
          If i + j = ArraySize(arr())
            ReDim arr(i + j + 1)        ;      16?, 
            arr(i + j + 1) = 32 
            sLine = sLine + "   "
          Else
            sLine = sLine + RSet(Hex(arr(i + j), #PB_Byte), 2, "0") + " "
          EndIf 
       Next j
       sLine = sLine + "| "
       For j = 0 To 15 
          If arr(i + j) < 32
            sLine = sLine + "."
          Else
            sLine = sLine + Chr(arr(i + j))
          EndIf
       Next j
       sLine = sLine + #CRLF$
       sText = sText + sLine  
     Next i
     FreeResMem(*stRes.RES)
   EndIf
 EndIf    
 ProcedureReturn sText
EndProcedure
 
Procedure OpenFileRes(FileName.s) 
  If FileName <> "" 
     If hModule
        FreeLibrary_(hModule)
        hModule = 0
     EndIf   
     hModule = InitResource(FileName)
     If hModule
       ClearGadgetItems(#Tree_0)
       RefreshView()
       SetWindowTitle(#Window_0, "Resource Viewer - [" +  FileName + "]")
       ico = ExtractIcon_(0, FileName, 0)
       If ico = 0
          ico = ExtractIcon_(0, "Shell32.dll", 2)
       EndIf
       AddGadgetItem(#Tree_0, -1, GetFilePart(FileName), ico)
       FillResTypes(hModule)
       tvExpandNode(#Tree_0, 0, 1)
     Else
       MessageRequester("Error", "Can't load file!")
     EndIf  
  EndIf
EndProcedure  

Procedure Main()
  If OpenWindow(#Window_0, 10, 10, 800, 600, "Resource Viewer", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_MaximizeGadget)
    SmartWindowRefresh(#Window_0, #True) 
    WindowBounds(#Window_0, 900, 670, #PB_Ignore, #PB_Ignore) 
    TreeGadget(#Tree_0, 0, 0, 0, 0, #PB_Tree_AlwaysShowSelection)
    ContainerGadget(#Container, 0, 0, 0, 0, #PB_Container_Raised)
    EditorGadget(#Edit, 0, 0, 826, 658, #PB_Editor_ReadOnly)
    SetGadgetFont(#Edit, LoadFont(100, "Lucida Console", 10))   ; Courier New  ; Lucida Console
    ImageGadget(#img, 100, 100, 820, 660, 0)
    CloseGadgetList()
    SetGadgetColor(#Edit, #PB_Gadget_BackColor, GetSysColor_(#COLOR_BTNFACE))
    SplitterGadget(#Splitter, 5, 10, 1090, 665, #Tree_0, #Container, #PB_Splitter_Vertical|#PB_Splitter_Separator)
    SetGadgetAttribute(#Splitter, #PB_Splitter_FirstMinimumSize, 150)
    SetGadgetAttribute(#Splitter, #PB_Splitter_SecondMinimumSize, 400)
    SetGadgetState(#Splitter,250)
    TextGadget(#txt, 5, 685, 600, 60, "")
    ImageGadget(#imgLogo, 970, 705, 100, 30, 0) 
    If CreateMenu(#MainMenu, WindowID(#Window_0))
       MenuTitle("File")
        MenuItem(#Open, "Open"   +Chr(9)+"Ctrl+D")
        MenuItem(#Exit, "Exit" )
       MenuTitle("?")
        MenuItem(#About, "About" )
    EndIf  
  EndIf
EndProcedure

Main()
DragAcceptFiles_(WindowID(#Window_0), 1)
AddKeyboardShortcut(#Window_0, #PB_Shortcut_Control | #PB_Shortcut_D, #Open)
SetWindowCallback(@WinCallback()) 

hRes = FindResource_(0, @"LOGO", #RT_RCDATA)
If hRes
  hGlob = LoadResource_(0, hRes) 
  lpbArray = LockResource_(hGlob)
  SetGadgetState(#imgLogo, CatchImage(#imgLogo, hGlob, SizeofResource_(0, hGlob)))
  FreeResource_(hGlob)
EndIf

If gdiplus_Init()
   gdiplus = 1
EndIf 

Repeat
  Event = WaitWindowEvent()
  Select Event
    Case #WM_DROPFILES
      *DropHandle = EventwParam()
      If *DropHandle
        *Buffer = AllocateMemory(#MAX_PATH)
        If *Buffer
          NbDroppedFiles = DragQueryFile_ (*DropHandle, $FFFFFFFF, *Buffer, #MAX_PATH)
          If NbDroppedFiles = 1 
            DragQueryFile_(*DropHandle, k, *Buffer, #MAX_PATH)
            DragFinish_(*DropHandle)
            File$=PeekS(*Buffer)
            If LCase(Right(File$, 3)) = "exe" Or LCase(Right(File$, 3)) = "dll"
              OpenFileRes(File$)
            EndIf
          Else
            MessageRequester("", "Only one file")
          EndIf 
          FreeMemory(*Buffer)
        EndIf  
      EndIf
    Case #PB_Event_Menu
      Select EventMenu()
        Case #Open
          File$ = OpenFileRequester("Please choose file to load",  "", "Executable (dll,exe)|*.dll;*.exe|All files (*.*)|*.*", 0)
           If File$ <> "" 
             OpenFileRes(File$) 
           EndIf
        Case #Exit
          RefreshView()
          CloseWindow(#Window_0)
          Break
        Case #About   
          MessageRequester("Resource Viewer 0.1", "   Coded by crc1" + #CRLF$ + "Copyright  2015", #MB_ICONINFORMATION)
      EndSelect
    Case #PB_Event_Gadget
      If EventGadget() = #Tree_0 And EventType() = #PB_EventType_Change
         If GetGadgetState(#Tree_0) <> -1 
           If GetGadgetItemData(#Tree_0, GetGadgetState(#Tree_0))
             RefreshView()
             ShowResource()
           EndIf  
         EndIf
      EndIf
    Case #PB_Event_CloseWindow
      EventWindow = EventWindow()
      If EventWindow = #Window_0
        RefreshView()
        CloseWindow(#Window_0)
        Break
      EndIf
  EndSelect
ForEver

; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 888
; FirstLine = 849
; Folding = ------
; EnableThread
; EnableXP
; Executable = 111.exe
; CompileSourceDirectory
; EnableUnicode