﻿Enumeration
  #Form
  #Canvas
  #Font
EndEnumeration 
 
DeclareModule Custom
  
  Structure CUSTOM_RADIO_BUTTON
    WindowId.l
    ParentId.l
    *CustomId
    Font.l
    Text.s
    TextIndent.i
    IsTextEllipsis.b
    X.i
    Y.i
    Width.i
    Height.l
    Radius.i
    BackgroundColor.i
    BackgroundNormal.i
    BackgroundHover.i
    BackgroundPressed.i
    StrokeColor.i
    StrokeNormal.i
    StrokeHover.i
    StrokePressed.i
    StrokeSize.i
    TextColor.i
    TextNormal.i
    TextHover.i
    TextPressed.i
    IsCheckMark.b
    MarkColor.i
    MarkNormal.i
    MarkHover.i
    MarkPressed.i
    isPressed.b
    isInside.b
    GroupName.s
  EndStructure
  
  Enumeration
    #PB_EventType_CustomMouseEnter
    #PB_EventType_CustomMouseLeave
    #PB_EventType_CustomLeftButtonClick
  EndEnumeration  
  
  Enumeration
    #PB_Color_CustomBackground
    #PB_Color_CustomStroke
    #PB_Color_CustomText
    #PB_Color_CustomMark
  EndEnumeration  
  
  Declare.l CustomRadioButton(WindowId.l, CanvasId.l, GroupName.s, Text.s, X.i, Y.i, Width.i, Height.i)
  Declare.b Checked(*Gadget.CUSTOM_RADIO_BUTTON, Flag.b)
  Declare SetCustomRadioButtonColor(*Gadget, Type.l, Normal.l, Hover.l, Pressed.l)
  Declare DrawRadioButton()
  
EndDeclareModule  
 
Module Custom
  
  Structure GROUPS
    Name.s
    Gadget.l
  EndStructure  
  
  Global NewList Gadgets.CUSTOM_RADIO_BUTTON()
  
  Global NewList Groups.GROUPS()
  
  Procedure.l CustomRadioButton(WindowId.l, CanvasId.l, GroupName.s, Text.s, X.i, Y.i, Width.i, Height.i)
    
    *Gadget.CUSTOM_RADIO_BUTTON = AddElement(Gadgets())
    If *Gadget
      With *Gadget
        \WindowId = WindowId
        \ParentId = CanvasId
        \CustomId = *Gadget
        \GroupName = GroupName
        \Font = LoadFont(#PB_Any, "Tahoma", 9)
        \Text = Text
        \TextIndent = 5
        \IsTextEllipsis = #True
        \X = X
        \Y = Y
        \Width = Width
        \Height = Height
        \Radius = 13
        \BackgroundNormal = RGBA(240, 240, 240, 255)
        \BackgroundHover = RGBA(230, 230, 230, 255)
        \BackgroundPressed = RGBA(250, 250, 250, 255)
        \StrokeNormal = RGBA(90, 90, 90, 255)
        \StrokeHover = RGBA(80, 80, 80, 255)
        \StrokePressed = RGBA(70, 70, 70, 255)
        \StrokeSize = 1
        \TextNormal = RGBA(90, 90, 90, 255)
        \TextHover = RGBA(60, 60, 60, 255)
        \TextPressed = RGBA(60, 60, 60, 255)
        \IsCheckMark = #False
        \MarkNormal = RGBA(46, 204, 113, 255)
        \MarkHover = RGBA(100, 204, 113, 255)
        \MarkPressed = RGBA(20, 204, 113, 255)
      EndWith
      
      ForEach Groups()
        If Groups()\Name = GroupName
          ProcedureReturn *Gadget
        EndIf  
      Next  
      
      If AddElement(Groups())
        Groups()\Name = GroupName
        ProcedureReturn *Gadget
      EndIf
      
    EndIf  
    ProcedureReturn -1
    
  EndProcedure  
  
  Procedure.b Checked(*Gadget.CUSTOM_RADIO_BUTTON, Flag.b)
    ForEach Groups()
      If Groups()\Name = *Gadget\GroupName
        If Groups()\Gadget <> *Gadget
          Groups()\Gadget = *Gadget
        EndIf   
      EndIf
    Next  
  EndProcedure  
  
  Procedure SetCustomRadioButtonColor(*Gadget, Type.l, Normal.l, Hover.l, Pressed.l)
    
    ForEach Gadgets()
      If Gadgets()\CustomId = *Gadget
        Select Type
          Case #PB_Color_CustomBackground
            Gadgets()\BackgroundNormal = Normal
            Gadgets()\BackgroundHover = Hover
            Gadgets()\BackgroundPressed = Pressed
          Case #PB_Color_CustomStroke
            Gadgets()\StrokeNormal = Normal
            Gadgets()\StrokeHover = Hover
            Gadgets()\StrokePressed = Pressed
          Case #PB_Color_CustomText
            Gadgets()\TextNormal = Normal
            Gadgets()\TextHover = Hover
            Gadgets()\TextPressed = Pressed
          Case #PB_Color_CustomMark
            Gadgets()\MarkNormal = Normal
            Gadgets()\MarkHover = Hover
            Gadgets()\MarkPressed = Pressed
        EndSelect    
      EndIf  
    Next  
    
  EndProcedure  
  
  Procedure DrawRadioButton()
    
    Protected GadgetText.s, Index.i, X.i, Y.i, Id
    
    Static CustomId.l
 
    ForEach Gadgets()
    
      If Gadgets()
        
        ForEach Groups()
          If Gadgets()\GroupName = Groups()\Name
            If Gadgets()\CustomId = Groups()\Gadget
              Gadgets()\IsCheckMark = #True
            Else
              Gadgets()\IsCheckMark = #False
            EndIf  
          EndIf  
        Next  
 
        If Gadgets()\Font
          VectorFont(FontID(Gadgets()\Font))
        EndIf 
        
        GadgetText = Gadgets()\Text
      
        While (VectorTextWidth(GadgetText) > Gadgets()\Width)
          If Gadgets()\IsTextEllipsis
            GadgetText = (Left(GadgetText, Len(GadgetText) - Index) + "...")
          Else
            Debug 1
            GadgetText = Left(GadgetText, Len(GadgetText) - Index)
          EndIf
          Index + 1
        Wend
        
        X = GetGadgetAttribute(Gadgets()\ParentId, #PB_Canvas_MouseX)
        Y = GetGadgetAttribute(Gadgets()\ParentId, #PB_Canvas_MouseY)
 
        AddPathBox(Gadgets()\X, Gadgets()\Y, Gadgets()\Width, Gadgets()\Height)
        If (GetGadgetAttribute(Gadgets()\ParentId, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
          If IsInsidePath(X, Y, #PB_Coordinate_Device)
            If CustomId = -1
              Gadgets()\isPressed = #True
              CustomId = Gadgets()\CustomId
              Gadgets()\BackgroundColor = Gadgets()\BackgroundPressed
              Gadgets()\StrokeColor = Gadgets()\StrokePressed
              Gadgets()\TextColor = Gadgets()\TextPressed
              Gadgets()\MarkColor = Gadgets()\MarkPressed
              If (Not Gadgets()\isInside)
                PostEvent(#PB_Event_Gadget, Gadgets()\WindowId, Gadgets()\CustomId, #PB_EventType_CustomMouseEnter)
                Gadgets()\isInside = #True
              EndIf
            Else
              If (Gadgets()\CustomId = CustomId)
                Gadgets()\isPressed = #True
                Gadgets()\BackgroundColor = Gadgets()\BackgroundPressed
                Gadgets()\StrokeColor = Gadgets()\StrokePressed
                Gadgets()\TextColor = Gadgets()\TextPressed
                Gadgets()\MarkColor = Gadgets()\MarkPressed
                If (Not Gadgets()\isInside)
                  PostEvent(#PB_Event_Gadget, Gadgets()\WindowId, CustomId, #PB_EventType_CustomMouseEnter)
                  Gadgets()\isInside = #True
                EndIf
              EndIf
            EndIf
          Else
            If Gadgets()\isPressed
              Gadgets()\BackgroundColor = Gadgets()\BackgroundHover
              Gadgets()\StrokeColor = Gadgets()\StrokeHover
              Gadgets()\TextColor = Gadgets()\TextHover
              Gadgets()\MarkColor = Gadgets()\MarkHover
            Else
              Gadgets()\BackgroundColor = Gadgets()\BackgroundNormal
              Gadgets()\StrokeColor = Gadgets()\StrokeNormal
              Gadgets()\TextColor = Gadgets()\TextNormal
              Gadgets()\MarkColor = Gadgets()\MarkNormal
            EndIf  
            If Gadgets()\isInside
              PostEvent(#PB_Event_Gadget, Gadgets()\WindowId, CustomId, #PB_EventType_CustomMouseLeave)
              Gadgets()\isInside = #False
            EndIf
          EndIf
        Else
          If IsInsidePath(X, Y, #PB_Coordinate_Device)
            If Gadgets()\isPressed And Gadgets()\isInside And (Gadgets()\CustomId = CustomId)
              Gadgets()\BackgroundColor = Gadgets()\BackgroundNormal
              Gadgets()\StrokeColor = Gadgets()\StrokeNormal
              Gadgets()\TextColor = Gadgets()\TextNormal
              Gadgets()\MarkColor = Gadgets()\MarkNormal
              Gadgets()\IsCheckMark = #True
              ForEach Groups()
                If Gadgets()\GroupName = Groups()\Name
                  Groups()\Gadget = Gadgets()\CustomId
                EndIf  
              Next 
              PostEvent(#PB_Event_Gadget, Gadgets()\WindowId, CustomId, #PB_EventType_CustomLeftButtonClick)
              CustomId = -1 
            Else
              CustomId = -1
              Gadgets()\BackgroundColor = Gadgets()\BackgroundHover
              Gadgets()\StrokeColor = Gadgets()\StrokeHover
              Gadgets()\TextColor = Gadgets()\TextHover
              Gadgets()\MarkColor = Gadgets()\MarkHover
            EndIf
            Gadgets()\isPressed = #False
            If (Not Gadgets()\isInside)
              PostEvent(#PB_Event_Gadget, Gadgets()\WindowId, CustomId, #PB_EventType_CustomMouseEnter)
              Gadgets()\isInside = #True
            EndIf
          Else
            Gadgets()\BackgroundColor = Gadgets()\BackgroundNormal
            Gadgets()\StrokeColor = Gadgets()\StrokeNormal
            Gadgets()\TextColor = Gadgets()\TextNormal
            Gadgets()\MarkColor = Gadgets()\MarkNormal
            If Gadgets()\isInside
              PostEvent(#PB_Event_Gadget, Gadgets()\WindowId, CustomId, #PB_EventType_CustomMouseLeave)
              Gadgets()\isInside = #False
            EndIf
          EndIf 
        EndIf
        
        VectorSourceColor(RGBA(0, 0, 0, 0))
        FillPath()
        
        AddPathCircle(Gadgets()\X + (Gadgets()\Radius / 2), Gadgets()\Y + (Gadgets()\Height / 2), (Gadgets()\Radius / 2))
        VectorSourceColor(Gadgets()\BackgroundColor)
        FillPath()
        
        VectorSourceColor(Gadgets()\StrokeColor)
        AddPathCircle(Gadgets()\X + (Gadgets()\Radius / 2), Gadgets()\Y + (Gadgets()\Height / 2), (Gadgets()\Radius / 2))
        StrokePath(Gadgets()\StrokeSize)
        
        If Gadgets()\IsCheckMark
          AddPathCircle(Gadgets()\X + (Gadgets()\Radius / 2), Gadgets()\Y + (Gadgets()\Height / 2), (Gadgets()\Radius / 2) - 3)
          VectorSourceColor(Gadgets()\MarkColor)
          FillPath()
        EndIf  
        
        VectorSourceColor(Gadgets()\TextColor)
        MovePathCursor((Gadgets()\X + Gadgets()\Radius) + Gadgets()\TextIndent, Gadgets()\Y + ((Gadgets()\Height / 2) - (VectorTextHeight(GadgetText) / 2)))
        AddPathText(GadgetText)
        FillPath()
      EndIf    
    Next
    
  EndProcedure  
  
EndModule
 
Procedure CanvasUpdate()
  
  Protected X.i, Y.i
  
  X = GadgetWidth(#Canvas)
  Y = GadgetHeight(#Canvas)
  
  If StartVectorDrawing(CanvasVectorOutput(#Canvas))
    VectorSourceColor(RGBA(220, 220, 220, 255))
    FillVectorOutput()
    
    MovePathCursor(10, 10)
    AddPathLine(X - 20, 0, #PB_Path_Relative)
    MovePathCursor(10, 10)
    AddPathLine(0, Y - 20, #PB_Path_Relative)
    MovePathCursor(10, Y - 10)
    AddPathLine(X - 20, 0, #PB_Path_Relative)
    MovePathCursor(X - 10, 10)
    AddPathLine(0, Y - 20, #PB_Path_Relative)
    VectorSourceColor(RGBA(120, 120, 120, 255))
    DashPath(2, 4, #PB_Path_SquareEnd)
 
    Custom::DrawRadioButton()
    
    StopVectorDrawing()
  EndIf
EndProcedure
 
Procedure WindowResize()
  If IsGadget(#Canvas)
    ResizeGadget(#Canvas, 0, 0, WindowWidth(EventWindow()), WindowHeight(EventWindow()))
    CanvasUpdate()
  EndIf
EndProcedure
 
If OpenWindow(#Form, 0, 0, 400, 200, "Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget)
  SmartWindowRefresh(#Form, #True)
  CanvasGadget(#Canvas, 0, 0, 400, 200)
 
  Radio1 = Custom::CustomRadioButton(#Form, #Canvas, "Group1", "Example RadioButton1 (Группа 1)", 20, 20, 200, 20)
  Radio2 = Custom::CustomRadioButton(#Form, #Canvas, "Group1", "Example RadioButton2 (Группа 1)", 20, 50, 200, 20)
  Custom::SetCustomRadioButtonColor(Radio2, Custom::#PB_Color_CustomMark, RGBA(255, 206, 12, 255), RGBA(229, 182, 11, 255), RGBA(229, 197, 82, 255))
 
  Radio3 = Custom::CustomRadioButton(#Form, #Canvas, "Group2", "Example RadioButton1 (Группа 2)", 20, 80, 200, 20)
  Custom::SetCustomRadioButtonColor(Radio3, Custom::#PB_Color_CustomStroke, RGBA(0, 148, 255, 255), RGBA(0, 133, 229, 255), RGBA(45, 153, 229, 255))
  Custom::SetCustomRadioButtonColor(Radio3, Custom::#PB_Color_CustomMark, RGBA(0, 148, 255, 255), RGBA(0, 133, 229, 255), RGBA(45, 153, 229, 255))
  
  Radio4 = Custom::CustomRadioButton(#Form, #Canvas, "Group2", "Example RadioButton2 (Группа 2)", 20, 110, 200, 20)
  Custom::SetCustomRadioButtonColor(Radio4, Custom::#PB_Color_CustomMark, RGBA(229, 45, 39, 255), RGBA(204, 40, 34, 255), RGBA(204, 79, 75, 255))
  
  Custom::Checked(Radio1, #True)
  Custom::Checked(Radio3, #True)
  
  CanvasUpdate()
  
  BindEvent(#PB_Event_SizeWindow, @WindowResize(), #Form)
  
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        Break
      Case #PB_Event_Gadget
        Select EventGadget()
          Case Radio1
            Select EventType()
              Case Custom::#PB_EventType_CustomLeftButtonClick
                SetWindowTitle(#Form, "RadioButton1 выбран (Группа 1)")
            EndSelect 
          Case Radio3
            Select EventType()
              Case Custom::#PB_EventType_CustomLeftButtonClick
                SetWindowTitle(#Form, "RadioButton1 выбран (Группа 2)")
            EndSelect
          Case Radio2
            Select EventType()
              Case Custom::#PB_EventType_CustomLeftButtonClick
                SetWindowTitle(#Form, "RadioButton2 выбран (Группа 1)")
            EndSelect 
          Case Radio4
            Select EventType()
              Case Custom::#PB_EventType_CustomLeftButtonClick
                SetWindowTitle(#Form, "RadioButton2 выбран (Группа 2)")
            EndSelect  
          Case #Canvas
            Select EventType()
              Case #PB_EventType_MouseMove
                CanvasUpdate()
              Case #PB_EventType_LeftButtonDown
                CanvasUpdate()
              Case #PB_EventType_LeftButtonUp
                CanvasUpdate()
            EndSelect    
        EndSelect    
    EndSelect
  ForEver
EndIf
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 407
; FirstLine = 368
; Folding = --
; EnableXP
; CompileSourceDirectory